package JointFeldmanProtocol;

import Communication.Network;
import meerkat.protobuf.DKGMessages;

/**
 * Created by Tzlil on 3/14/2016.
 */
public class DKGUserImplAbort extends DistributedKeyGenerationUserImpl {

    final int abortStage;
    int stage;
    public DKGUserImplAbort(DistributedKeyGeneration dkg, Network network, int abortStage) {
        super(dkg, network);
        this.abortStage = abortStage;// 1 - 2
        this.stage = 1;
    }


    private void sendAbort(){
        user.broadcast(DKGMessages.Mail.Type.ABORT,DKGMessages.EmptyMessage.getDefaultInstance());
    }

    @Override
    protected void stage1() {
        if(stage < abortStage)
            super.stage1();
        else if(stage == abortStage){
            sendAbort();
        }
        stage++;
    }

    @Override
    protected void stage2() {
        if(stage < abortStage)
            super.stage2();
        else if(stage == abortStage){
            sendAbort();
        }
        stage++;
    }

    @Override
    protected void stage3() {
        if(stage < abortStage)
            super.stage3();
        else if(stage == abortStage){
            sendAbort();
        }
        stage++;
    }

    @Override
    protected void stage4() {
        if(stage < abortStage)
            super.stage4();
        else if(stage == abortStage){
            sendAbort();
        }
        stage++;
    }
}
