package JointFeldmanProtocol;

import ShamirSecretSharing.Polynomial;

import java.math.BigInteger;
import java.util.Arrays;

/**
 * Created by Tzlil on 3/14/2016.
 *
 * contains all relevant information on specific party during
 * the run of Joint Feldamn protocol
 */
// TODO: comments for every field.
public class DistributedKeyGenerationParty {
    public final int id;
    public Polynomial.Point share;
    public BigInteger[] commitments;
    public boolean doneFlag;
    public DistributedKeyGeneration.ComplaintState[] complaints;
    public boolean aborted;

    public DistributedKeyGenerationParty(int id, int n, int t) {
        this.id = id;
        this.share = null;
        this.doneFlag = false;
        this.complaints = new DistributedKeyGeneration.ComplaintState[n];
        Arrays.fill(this.complaints, DistributedKeyGeneration.ComplaintState.OK);
        this.commitments = new BigInteger[t + 1];
        this.aborted = false;
    }
}
